﻿Option Infer Off
Option Strict On
Option Explicit On

Public Delegate Function MathFunction(ByVal x As Double) As Double

Public Class Functions
    Public C As List(Of Double) ' Konstantenparameter

    <MathFunc("Konstante Funktion", 3)> _
    Public Function ConstFunc(ByVal x As Double) As Double
        Return C(0)
    End Function

    <MathFunc("Lineare Funktion", 0.5, 15)> _
    Public Function Linear(ByVal x As Double) As Double

        Return C(0) * x + C(1)

    End Function

    <MathFunc("Quadratische Funktion", 0.01, 0, -100)> _
    Public Function Quadratic(ByVal x As Double) As Double

        Return Linear(x) * x + C(2)

    End Function

    <MathFunc("Kubische Funktion", 0.0001, 0, -2, 0)> _
    Public Function Cubic(ByVal x As Double) As Double

        Return Quadratic(x) * x + C(3)

    End Function

    <MathFunc("Sinus", 0.05, 100, 20, 0)> _
    Public Function Sinus(ByVal x As Double) As Double

        Return Math.Sin(Linear(x)) * C(2) + C(3)

    End Function

    <MathFunc("Exponentialfunktion", 0.007, 0, 50, 0)> _
    Public Function Exponent(ByVal x As Double) As Double

        Return Math.Exp(Linear(x)) * C(2) + C(3)

    End Function

    <MathFunc("DamperedHarmonic", -0.007, 0, 25, 0, 0.1, 10, 0)> _
    Public Function DamperedHarmonic(ByVal x As Double) As Double

        Return Exponent(x) * Math.Sin(C(4) * x + C(5)) + C(6)

    End Function

End Class
