﻿Public Class Form1

    Private mView As New MathFunctionView
    Private mDatabase As New Dictionary(Of String, MathFunction)
    Private mFunctions As New Functions

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        mDatabase.ReflectFunctions(mFunctions) ' Das ist alles

        cboFunction.Items.AddRange(mDatabase.Keys.ToArray)
        cboFunction.SelectedIndex = 0
    End Sub

    Private Sub Form1_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Resize

        With Me.ClientSize
            PictureBox1.Size = New Size(.Width - PictureBox1.Left - 12, .Height - PictureBox1.Top - 12)
        End With

        mView.Size = PictureBox1.Size
    End Sub

    Private Sub ChangeFunction(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cboFunction.SelectedIndexChanged
        If cboFunction.SelectedItem IsNot Nothing Then
            mView.DrawFunction(mDatabase(cboFunction.SelectedItem))
            PictureBox1.Refresh()
        End If
    End Sub

    Private Sub PictureBox1_Paint(ByVal sender As Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles PictureBox1.Paint
        If mView.Buffer IsNot Nothing Then
            e.Graphics.DrawImage(mView.Buffer, 0, 0)
        Else
            e.Graphics.Clear(PictureBox1.BackColor)
        End If
    End Sub

End Class
